<template>
  <header v-if="isHeaderShow">
    <div
      id="sbo-header"
      class="flex items-center pl-3.5 pr-3.5 py-[0.569rem] border-b4 bg-background1 justify-between"
    >
      <div class="flex items-center">
        <new-black-theme-hamburger-menu class="hamburger-sbo" />
        <div v-if="!logo.IsHidden" class="logo py-1.5 w-1/2">
          <nuxt-link :to="logo.HyperLink ? `/${logo.HyperLink}` : '/'">
            <figure class="object-contain w-[130px] h-[36px]">
              <img
                :src="logo.ImagePath"
                alt="Dark Theme"
                class="w-[130px] h-[36px] object-contain ml-4 object-left"
              />
            </figure>
          </nuxt-link>
        </div>
      </div>
      <div v-if="!isAuth" class="flex items-center w-1/2 gap-3 justify-end">
        <button class="btn bg-secondary" @click="toggleAuthModal('login')">
          <span class="text-base font-bold leading-4 break-words">{{
            $t("capital_login")
          }}</span>
        </button>
        <button v-if="!register.IsHidden" class="btn bg-primary" :id="ID.SIGNUP" @click="toggleAuthModal('register')">
          <span class="text-base font-bold leading-4 break-words pointer-events-none">{{
            $t("joinnow")
          }}</span>
        </button>
      </div>
      <lazy-theme-mobile-sbo-components-language v-else />
    </div>
  </header>
</template>

<script lang="ts">
import { computed, defineComponent, PropType, toRefs } from "vue";
import { useRoute } from "vue-router";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import { store } from "@/store";

const shownRoute = [
  "sports",
  "virtual-sports",
  "live-casino",
  "games",
  "GameEntryInitial",
  "keno",
  "poker",
  "cockfight",
  "lottery",
  "promotion",
  "contact-us",
  "index",
  "games-filter",
];

export default defineComponent({
  name: "MHeader1",
  props: {
    auth: {
      type: Boolean,
      default: false,
    },
    themeProperties: {
      type: Array as PropType<Array<IThemePropertiesFromApi>>,
      required: true,
    },
    includeAnnouncement: {
      type: Boolean,
      required: false,
      default: false,
    },
  },
  setup(props) {
    const logo = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          props.themeProperties,
          "logo"
        )
    );
    const register = computed(() =>
      themePropertyHelper.getSingleThemeProperty(
        store.state.companyThemePropertiesFromApi.ThemeProperties,
        "register"
      )
    );
    const route = useRoute();
    const { name } = toRefs(route);
    const isHeaderShow = computed(() =>
      shownRoute.includes(name.value as string)
    );
    const announcement = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          store.state.companyThemePropertiesFromApi.ThemeProperties,
          "announcement"
        )
    );
    const { getAssetImage } = commonHelper;
    const isAuth = computed(() => store.state.auth);
    const toggleAuthModal = (option: "login" | "register"): void => {
      if (option === "login") {
        store.commit("updateLoginDialog", !store.state.showLoginDialog);
      }
      if (option === "register") {
        store.commit("updateRegisterDialog", !store.state.showRegisterDialog);
      }
    };
    return {
      logo,
      isHeaderShow,
      getAssetImage,
      toggleAuthModal,
      announcement,
      isAuth,
      register,
    };
  },
});
</script>
<style scoped>
.btn {
  @apply inline-block text-center transition-colors duration-300;
  padding: 0.125rem 0.5rem !important;
  min-height: 34px;
  border-radius: 6px;
  width: fit-content;
  min-width: 75.81px !important;
  text-transform: capitalize;
}
</style>
